#include <cstdlib>
#include <cassert>
#include <vector>
#include <map>
#include <iostream>
#include <iterator>


extern int marcoverbose;
using namespace std;

  
class Edge {
  friend std::ostream& operator<<(std::ostream &os, const Edge &e) {
    copy(e.members.begin(),e.members.end(),ostream_iterator<int>(os, " "));
    os<<" ("<<e.bound<<")";
    os<<endl;
    return os;
  }
public:
    
  vector<int> members;

  int bound;
  long weight;
  int idx; 				
    
  Edge() {};				// Constructor
  ~Edge() {};				// Destructor
    
  Edge(const Edge &a) {
    if (&a!=NULL && &a!=this)
      {
	members=a.members;
	weight=a.weight;
	idx=a.idx;
	bound = a.bound;
      } 
  };
  Edge operator=(const Edge a) {
    members=a.members;
    weight=a.weight;
    idx=a.idx;
    bound = a.bound;
    return *this;
  }
};


class Vertex {
  friend std::ostream& operator<<(std::ostream &os, const Vertex &v) {
    os <<v.id<<" "<<v.weight<<endl;
    return os;
  }
public:
  long weight;
  int id;
    
  Vertex() {};				// Constructor
  ~Vertex() {};				// Destructor
    
  Vertex(const Vertex &a) {
    if (&a!=NULL && &a!=this)
      {
	weight=a.weight;
	id=a.id;
      } 
  };
  Vertex operator=(const Vertex a) {
    weight=a.weight;
    id=a.id;
    return *this;
  }
};

class Graph {
public:
  Graph() {};
  Graph(const char *instance_name);
  ~Graph() {};
  void check_sln();    
  void read_sln(const char *solfile_name);    
  int num_of_vertices;
  int num_of_edges;
  int cost;
  std::map<const int, Edge> edges;
  std::map<const int, Vertex> vertices;
  std::vector<int> solution;
};
